unit SubHunt_kod;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus, StdCtrls, checklst, WaveMix;

type
  TForm1 = class(TForm)
    PanelWater: TPanel;
    PanelSky: TPanel;
    Boat: TImage;
    TimerBoat: TTimer;
    Bomb1: TImage;
    Bomb2: TImage;
    Bomb3: TImage;
    Bomb4: TImage;
    Bomb5: TImage;
    Sub: TImage;
    TimerSub: TTimer;
    SubBomb1: TImage;
    SubBomb2: TImage;
    SubBomb3: TImage;
    TimerDod: TTimer;
    TimerWave: TTimer;
    Wave: TImage;
    Cloud: TImage;
    Plane: TImage;
    TimerPlane: TTimer;
    Label3: TLabel;
    PanelHelp: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Island: TImage;
    Label11: TLabel;
    Panel1: TPanel;
    OK: TButton;
    Image1: TImage;
    PlaneHelp: TImage;
    SubHelp: TImage;
    Label10: TLabel;
    Label12: TLabel;
    Man: TImage;
    ManHelp: TImage;
    Label13: TLabel;
    Image2: TImage;
    Menu1: TMainMenu;
    Game1: TMenuItem;
    New1: TMenuItem;
    Continue1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Quit1: TMenuItem;
    N1: TMenuItem;
    Panel2: TPanel;
    SubLeft: TImage;
    SubRight: TImage;
    Explode: TImage;
    PlaneLeft: TImage;
    ManOrg: TImage;
    PlaneRight: TImage;
    Bomb: TImage;
    SubBomb: TImage;
    BoatRight: TImage;
    BoatLeft: TImage;
    Sub2: TImage;
    Sub2Bomb1: TImage;
    Sub2Bomb2: TImage;
    Sub2Bomb3: TImage;
    Panel3: TPanel;
    Score: TLabel;
    Label1: TLabel;
    Panel4: TPanel;
    Liv1: TImage;
    Liv2: TImage;
    Liv3: TImage;
    PanelHigh: TPanel;
    HighList: TListBox;
    Label2: TLabel;
    HighText: TEdit;
    Panel5: TPanel;
    OK2: TButton;
    N3: TMenuItem;
    N2: TMenuItem;
    HighScore1: TMenuItem;
    Save: TButton;
    N4: TMenuItem;
    WaveMix1: TWaveMix;
    procedure FormCreate(Sender: TObject);
    procedure TimerBoatTimer(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TimerSubTimer(Sender: TObject);
    procedure TimerDodTimer(Sender: TObject);
    procedure TimerWaveTimer(Sender: TObject);
    procedure PlaneClick(Sender: TObject);
    procedure TimerPlaneTimer(Sender: TObject);
    procedure OKClick(Sender: TObject);
    procedure ManClick(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Continue1Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure Quit1Click(Sender: TObject);
    procedure Game1Click(Sender: TObject);
    procedure HighScore1Click(Sender: TObject);
    procedure HighTextExit(Sender: TObject);
    procedure OK2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PanelSkyClick(Sender: TObject);
    procedure IslandClick(Sender: TObject);


  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Vanster: Boolean;
  SubVanster: Boolean;
  Sub2Vanster: Boolean;
  ManVanster: Boolean;
  SubUpp: Boolean;
  Sub2Upp: Boolean;
  Lever: Boolean;
  SubLever: Boolean;
  Sub2Lever: Boolean;
  Bomber: Array [1..5] of Integer;
  SubBomber: Array [1..3] of Integer;
  Sub2Bomber: Array [1..3] of Integer;
  SubDuktig: Integer;
  PlaneLever: Boolean;
  PlaneVanster: Boolean;
  Liv:Integer;
  Inifile: TextFile;
  HighScore: Array [0..9] of Integer;
  W: Array [0..5] of PMixWave;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var I:Integer;
    S:String;
begin
  w[0] := WaveMix1.OpenFromFile('C:\Windows\Media\Hit_Mape.wav');
  w[1] := WaveMix1.OpenFromFile('C:\Windows\Media\Cloak_st.wav');
  w[2] := WaveMix1.OpenFromFile('C:\Windows\Media\Explode.wav');
  w[3] := WaveMix1.OpenFromFile('C:\Windows\Media\Explode.wav');
  w[4] := WaveMix1.OpenFromFile('C:\Windows\Media\Explode.wav');
  w[5] := WaveMix1.OpenFromFile('C:\Windows\Media\Cannon2.wav');

  S:='SubHunt.qwe';
{$I-}
  AssignFile(IniFile,S);
  FileMode := 0;  {Read only}
  Reset(IniFile);
{$I+}

  if IOResult = 0 then
  begin
    for I:=0 to 9 do
    begin
      Readln(IniFile,S);
      HighScore[I]:=StrToInt(S);
    end;
    for I:=0 to 9 do
    begin
      Readln(IniFile,S);
      HighList.Items[I]:=S;
    end;
    CloseFile(IniFile);
  end
  else
  begin
    HighList.Items[0]:='3000   Henrik';
    HighScore[0]:=3000;
    HighList.Items[1]:='2500   Henrik';
    HighScore[1]:=2500;
    HighList.Items[2]:='2100   Henrik';
    HighScore[2]:=2100;
    HighList.Items[3]:='1600   Henrik';
    HighScore[3]:=1600;
    HighList.Items[4]:='1200   Henrik';
    HighScore[4]:=1200;
    HighList.Items[5]:='550     Henrik';
    HighScore[5]:=550;
    HighList.Items[6]:='500     Henrik';
    HighScore[6]:=500;
    HighList.Items[7]:='200     Henrik';
    HighScore[7]:=200;
    HighList.Items[8]:='50       Henrik';
    HighScore[8]:=50;
    HighList.Items[9]:='10       Henrik';
    HighScore[9]:=10;
  end;

  Liv:=0;
  SubDuktig:=0;
  Vanster:=False;
  SubVanster:=True;
  Sub2Vanster:=True;
  ManVanster:=True;
  SubUpp:=True;
  Sub2Upp:=True;
  Sub.Top:=400;
  Sub2.Top:=400;
  Lever:=True;
  SubLever:=True;
  Sub2Lever:=True;
  PlaneLever:=True;
  Boat.Top:=-40;
  Boat.Picture:=BoatRight.Picture;
  Sub.Picture:=SubLeft.Picture;
  Sub2.Picture:=SubLeft.Picture;
  SubHelp.Picture:=SubRight.Picture;
  PlaneHelp.Picture:=PlaneRight.Picture;
  ManHelp.Picture:=ManOrg.Picture;

  Bomb1.Picture:=Bomb.Picture;
  Bomb2.Picture:=Bomb.Picture;
  Bomb3.Picture:=Bomb.Picture;
  Bomb4.Picture:=Bomb.Picture;
  Bomb5.Picture:=Bomb.Picture;

  SubBomb1.Picture:=SubBomb.Picture;
  SubBomb2.Picture:=SubBomb.Picture;
  SubBomb3.Picture:=SubBomb.Picture;
  Sub2Bomb1.Picture:=SubBomb.Picture;
  Sub2Bomb2.Picture:=SubBomb.Picture;
  Sub2Bomb3.Picture:=SubBomb.Picture;
  Liv1.Picture:=BoatRight.Picture;
  Liv2.Picture:=BoatRight.Picture;
  Liv3.Picture:=BoatRight.Picture;
end;

procedure TForm1.TimerBoatTimer(Sender: TObject);
var R:Integer;
begin
  if Vanster = True then
    Boat.Left:=Boat.Left-2
  else
    Boat.Left:=Boat.Left+2;

  if Boat.Left<-40 then
  begin
    Boat.Left:=500;
  end;

  if Boat.Left>500 then
  begin
    Boat.Left:=-40;
  end;

  R:=Random(20);
  if (R=0) and Lever then
  begin
    if Boat.Top = 58 then
      Boat.Top:= 59
    else
      Boat.Top:=58;
  end;

  R:=Random(5);
  if (R=1) and not Lever then
    Boat.Top:=Boat.Top+1;

  if Bomber[1]>=1 then
    Bomb1.Top:=Bomb1.Top+3;
  if Bomber[2]>=1 then
    Bomb2.Top:=Bomb2.Top+3;
  if Bomber[3]>=1 then
    Bomb3.Top:=Bomb3.Top+3;
  if Bomber[4]>=1 then
    Bomb4.Top:=Bomb4.Top+3;
  if Bomber[5]>=1 then
    Bomb5.Top:=Bomb5.Top+3;

  if Bomb1.Top>360 then
  begin
    Bomb1.Picture:=Explode.Picture;
    if Bomber[1]=1 then
      WaveMix1.Play( 2, w[2], nil, WMIX_QUEUEWAVE, 0 );
    Bomber[1]:=2;
  end;
  if Bomb2.Top>360 then
  begin
    Bomb2.Picture:=Explode.Picture;
    if Bomber[2]=1 then
      WaveMix1.Play( 2, w[2], nil, WMIX_QUEUEWAVE, 0 );
    Bomber[2]:=2;
  end;
  if Bomb3.Top>360 then
  begin
    Bomb3.Picture:=Explode.Picture;
    if Bomber[3]=1 then
      WaveMix1.Play( 2, w[2], nil, WMIX_QUEUEWAVE, 0 );
    Bomber[3]:=2;
  end;
  if Bomb4.Top>360 then
  begin
    Bomb4.Picture:=Explode.Picture;
    if Bomber[4]=1 then
      WaveMix1.Play( 2, w[2], nil, WMIX_QUEUEWAVE, 0 );
    Bomber[4]:=2;
  end;
  if Bomb5.Top>360 then
  begin
    Bomb5.Picture:=Explode.Picture;
    if Bomber[5]=1 then
      WaveMix1.Play( 2, w[2], nil, WMIX_QUEUEWAVE, 0 );
    Bomber[5]:=2;
  end;

  if Bomb1.Top>390 then
  begin
    Bomber[1]:=0;
    Bomb1.Top:=1;
  end;
  if Bomb2.Top>390 then
  begin
    Bomber[2]:=0;
    Bomb2.Top:=1;
  end;
  if Bomb3.Top>390 then
  begin
    Bomber[3]:=0;
    Bomb3.Top:=1;
  end;
  if Bomb4.Top>390 then
  begin
    Bomber[4]:=0;
    Bomb4.Top:=1;
  end;
  if Bomb5.Top>390 then
  begin
    Bomber[5]:=0;
    Bomb5.Top:=1;
  end;

  if ((SubBomb1.Top > Boat.Top+5) and
     (SubBomb1.Top < Boat.Top+Boat.Height) and
     (SubBomb1.Left > Boat.Left) and
     (SubBomb1.Left < Boat.Left+Boat.Width)) or
     ((SubBomb2.Top > Boat.Top+5) and
     (SubBomb2.Top < Boat.Top+Boat.Height) and
     (SubBomb2.Left > Boat.Left+5) and
     (SubBomb2.Left < Boat.Left+Boat.Width)) or
     ((SubBomb3.Top > Boat.Top+5) and
     (SubBomb3.Top < Boat.Top+Boat.Height) and
     (SubBomb3.Left > Boat.Left+5) and
     (SubBomb3.Left < Boat.Left+Boat.Width)) or
     ((Sub2Bomb1.Top > Boat.Top+5) and
     (Sub2Bomb1.Top < Boat.Top+Boat.Height) and
     (Sub2Bomb1.Left > Boat.Left) and
     (Sub2Bomb1.Left < Boat.Left+Boat.Width)) or
     ((Sub2Bomb2.Top > Boat.Top+5) and
     (Sub2Bomb2.Top < Boat.Top+Boat.Height) and
     (Sub2Bomb2.Left > Boat.Left+5) and
     (Sub2Bomb2.Left < Boat.Left+Boat.Width)) or
     ((Sub2Bomb3.Top > Boat.Top+5) and
     (Sub2Bomb3.Top < Boat.Top+Boat.Height) and
     (Sub2Bomb3.Left > Boat.Left+5) and
     (Sub2Bomb3.Left < Boat.Left+Boat.Width)) then
  begin
     Boat.AutoSize:=False;
     Boat.Stretch:=True;
     Boat.Picture:=Explode.Picture;
     Lever:=False;
     TimerDod.Enabled:=True;
     SubBomb1.Picture:=Explode.Picture;
     SubBomb2.Picture:=Explode.Picture;
     SubBomb3.Picture:=Explode.Picture;
     Sub2Bomb1.Picture:=Explode.Picture;
     Sub2Bomb2.Picture:=Explode.Picture;
     Sub2Bomb3.Picture:=Explode.Picture;
  end;

end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  TimerSub.Enabled:=True;
  TimerWave.Enabled:=True;
  PanelWater.Caption:='';
  if PanelHelp.Visible=True then
    key:=49;

  if liv>=1 then
  begin
    Continue1.Enabled:=True;
    TimerBoat.Enabled:=True;
    TimerPlane.Enabled:=True;
    Man.Visible:=True;
    Plane.Visible:=True;
  end;

  if key = VK_LEFT then
  begin
    Boat.Picture:=BoatLeft.Picture;
    Vanster:=True;
  end
  else if key = VK_RIGHT then
  begin
    Boat.Picture:=BoatRight.Picture;
    Vanster:=False;
  end
  else if key = VK_SPACE then
  begin
    if Bomber[1]=0 then
    begin
      WaveMix1.Play( 0, w[0], nil, WMIX_QUEUEWAVE, 0 );
      Bomb1.Picture:=Bomb.Picture;
      Bomber[1]:=1;
      Bomb1.Top:=77;
      Bomb1.Left:=Boat.Left+30;
      Bomb1.Visible:=True;
    end
    else if Bomber[2]=0 then
    begin
      WaveMix1.Play( 0, w[0], nil, WMIX_QUEUEWAVE, 0 );
      Bomb2.Picture:=Bomb.Picture;
      Bomber[2]:=1;
      Bomb2.Top:=77;
      Bomb2.Left:=Boat.Left+30;
      Bomb2.Visible:=True;
    end
    else if Bomber[3]=0 then
    begin
      WaveMix1.Play( 0, w[0], nil, WMIX_QUEUEWAVE, 0 );
      Bomb3.Picture:=Bomb.Picture;
      Bomber[3]:=1;
      Bomb3.Top:=77;
      Bomb3.Left:=Boat.Left+30;
      Bomb3.Visible:=True;
    end
    else if Bomber[4]=0 then
    begin
      WaveMix1.Play( 0, w[0], nil, WMIX_QUEUEWAVE, 0 );
      Bomb4.Picture:=Bomb.Picture;
      Bomber[4]:=1;
      Bomb4.Top:=77;
      Bomb4.Left:=Boat.Left+30;
      Bomb4.Visible:=True;
    end
    else if Bomber[5]=0 then
    begin
      WaveMix1.Play( 0, w[0], nil, WMIX_QUEUEWAVE, 0 );
      Bomb5.Picture:=Bomb.Picture;
      Bomber[5]:=1;
      Bomb5.Top:=77;
      Bomb5.Left:=Boat.Left+30;
      Bomb5.Visible:=True;
    end;
  end
  else if (key<>13) and ((Liv>=1) or (PanelHelp.Visible=True)) then
  begin
    PanelWater.Caption:='Pause';
    TimerBoat.Enabled:=False;
    TimerSub.Enabled:=False;
    TimerWave.Enabled:=False;
    TimerPlane.Enabled:=False;
    Continue1.Enabled:=True;
    Man.Visible:=False;
    Plane.Visible:=False;
  end;

end;

procedure TForm1.TimerSubTimer(Sender: TObject);
var R:Integer;
begin

  if Sub.Left<-40 then
  begin
    Sub.Left:=500;
  end;
  if Sub2.Left<-40 then
  begin
    Sub2.Left:=500;
  end;

  if Sub.Left>500 then
  begin
    Sub.Left:=-40;
  end;
  if Sub2.Left>500 then
  begin
    Sub2.Left:=-40;
  end;

  if SubVanster then
    Sub.Left:=Sub.Left-1
  else
    Sub.Left:=Sub.Left+1;
  if Sub2Vanster then
    Sub2.Left:=Sub2.Left-1
  else
    Sub2.Left:=Sub2.Left+1;

  if Sub.Top<180 then
  begin
    SubUpp:=False;
  end;
  if Sub2.Top<180 then
  begin
    Sub2Upp:=False;
  end;

  if Sub.Top>350 then
  begin
    SubUpp:=True;
  end;
  if Sub2.Top>350 then
  begin
    Sub2Upp:=True;
  end;

  R:=random(5);
  if R=0 then
  begin
  if SubUpp then
    Sub.Top:=Sub.Top-2
  else
    Sub.Top:=Sub.Top+1;
  end;

  R:=random(5);
  if R=0 then
  begin
  if Sub2Upp then
    Sub2.Top:=Sub2.Top-2
  else
    Sub2.Top:=Sub2.Top+1;
  end;

  R:=random(200);
  if (R=0) and SubLever then
  begin
    if SubVanster then
    begin
      SubVanster:=False;
      Sub.Picture:=SubRight.Picture;
    end
    else
    begin
      SubVanster:=True;
      Sub.Picture:=SubLeft.Picture;
    end;
  end;

  R:=random(200);
  if (R=0) and SubLever then
  begin
    if Sub2Vanster then
    begin
      Sub2Vanster:=False;
      Sub2.Picture:=SubRight.Picture;
    end
    else
    begin
      Sub2Vanster:=True;
      Sub2.Picture:=SubLeft.Picture;
    end;
  end;

  R:=random(100);
  if R=0 then
  begin
    if SubUpp then
      SubUpp:=False
    else
      SubUpp:=True;
  end;

  R:=random(100);
  if R=0 then
  begin
    if Sub2Upp then
      Sub2Upp:=False
    else
      Sub2Upp:=True;
  end;

  R:=random(100);
  if liv<1 then
    R:=0;
  if (R=1) and SubLever then
  begin
    if SubBomber[1]=0 then
    begin
      WaveMix1.Play( 1, w[1], nil, WMIX_QUEUEWAVE, 0 );
      SubBomb1.Picture:=SubBomb.Picture;
      SubBomber[1]:=1;
      SubBomb1.Top:=Sub.Top;
      SubBomb1.Left:=Sub.Left+10;
      SubBomb1.Visible:=True;
    end
    else if SubBomber[2]=0 then
    begin
      WaveMix1.Play( 1, w[1], nil, WMIX_QUEUEWAVE, 0 );
      SubBomb2.Picture:=SubBomb.Picture;
      SubBomber[2]:=1;
      SubBomb2.Top:=Sub.Top;
      SubBomb2.Left:=Sub.Left+10;
      SubBomb2.Visible:=True;
    end
    else if SubBomber[3]=0 then
    begin
      WaveMix1.Play( 1, w[1], nil, WMIX_QUEUEWAVE, 0 );
      SubBomb3.Picture:=SubBomb.Picture;
      SubBomber[3]:=1;
      SubBomb3.Top:=Sub.Top;
      SubBomb3.Left:=Sub.Left+10;
      SubBomb3.Visible:=True;
    end;
  end;

  R:=random(100);
  if liv<1 then
    R:=0;
  if (R=1) and Sub2Lever then
  begin
    if Sub2Bomber[1]=0 then
    begin
      WaveMix1.Play( 1, w[1], nil, WMIX_QUEUEWAVE, 0 );
      Sub2Bomb1.Picture:=SubBomb.Picture;
      Sub2Bomber[1]:=1;
      Sub2Bomb1.Top:=Sub2.Top;
      Sub2Bomb1.Left:=Sub2.Left+10;
      Sub2Bomb1.Visible:=True;
    end
    else if Sub2Bomber[2]=0 then
    begin
      WaveMix1.Play( 1, w[1], nil, WMIX_QUEUEWAVE, 0 );
      Sub2Bomb2.Picture:=SubBomb.Picture;
      Sub2Bomber[2]:=1;
      Sub2Bomb2.Top:=Sub2.Top;
      Sub2Bomb2.Left:=Sub2.Left+10;
      Sub2Bomb2.Visible:=True;
    end
    else if Sub2Bomber[3]=0 then
    begin
      WaveMix1.Play( 1, w[1], nil, WMIX_QUEUEWAVE, 0 );
      Sub2Bomb3.Picture:=SubBomb.Picture;
      Sub2Bomber[3]:=1;
      Sub2Bomb3.Top:=Sub2.Top;
      Sub2Bomb3.Left:=Sub2.Left+10;
      Sub2Bomb3.Visible:=True;
    end;
  end;

  if SubDuktig < 50 then
    R:=2
  else if SubDuktig < 100 then
    R:=3
  else if SubDuktig < 400 then
    R:=4
  else
    R:=5;

  if SubBomber[1]>=1 then
  begin
    SubBomb1.Top:=SubBomb1.Top-2;
    if Boat.Left+31<SubBomb1.Left then
      SubBomb1.Left:=SubBomb1.Left-random(R)
    else
      SubBomb1.Left:=SubBomb1.Left+random(R);
  end;
  if Sub2Bomber[1]>=1 then
  begin
    Sub2Bomb1.Top:=Sub2Bomb1.Top-2;
    if Boat.Left+31<Sub2Bomb1.Left then
      Sub2Bomb1.Left:=Sub2Bomb1.Left-random(R)
    else
      Sub2Bomb1.Left:=Sub2Bomb1.Left+random(R);
  end;

  if SubBomber[2]>=1 then
  begin
    SubBomb2.Top:=SubBomb2.Top-2;
    if Boat.Left+31<SubBomb2.Left then
      SubBomb2.Left:=SubBomb2.Left-random(R)
    else
      SubBomb2.Left:=SubBomb2.Left+random(R);
  end;

  if Sub2Bomber[2]>=1 then
  begin
    Sub2Bomb2.Top:=Sub2Bomb2.Top-2;
    if Boat.Left+31<Sub2Bomb2.Left then
      Sub2Bomb2.Left:=Sub2Bomb2.Left-random(R)
    else
      Sub2Bomb2.Left:=Sub2Bomb2.Left+random(R);
  end;

  if SubBomber[3]>=1 then
  begin
    SubBomb3.Top:=SubBomb3.Top-2;
    if Boat.Left+31<SubBomb3.Left then
      SubBomb3.Left:=SubBomb3.Left-1
    else
      SubBomb3.Left:=SubBomb3.Left+1;
  end;
  if Sub2Bomber[3]>=1 then
  begin
    Sub2Bomb3.Top:=Sub2Bomb3.Top-2;
    if Boat.Left+31<Sub2Bomb3.Left then
      Sub2Bomb3.Left:=Sub2Bomb3.Left-1
    else
      Sub2Bomb3.Left:=Sub2Bomb3.Left+1;
  end;

  if SubBomb1.Top < 80 then
  begin
    if SubBomber[1]=1 then
      WaveMix1.Play( 3, w[3], nil, WMIX_QUEUEWAVE, 0 );
    SubBomber[1]:=2;
    SubBomb1.Picture:=Explode.Picture;
  end;
  if Sub2Bomb1.Top < 80 then
  begin
    if Sub2Bomber[1]=1 then
      WaveMix1.Play( 4, w[4], nil, WMIX_QUEUEWAVE, 0 );
    Sub2Bomber[1]:=2;
    Sub2Bomb1.Picture:=Explode.Picture;
  end;
  if SubBomb2.Top < 80 then
  begin
    if SubBomber[2]=1 then
      WaveMix1.Play( 3, w[3], nil, WMIX_QUEUEWAVE, 0 );
    SubBomber[2]:=2;
    SubBomb2.Picture:=Explode.Picture;
  end;
  if Sub2Bomb2.Top < 80 then
  begin
    if Sub2Bomber[2]=1 then
      WaveMix1.Play( 4, w[4], nil, WMIX_QUEUEWAVE, 0 );
    Sub2Bomber[2]:=2;
    Sub2Bomb2.Picture:=Explode.Picture;
  end;
  if SubBomb3.Top < 80 then
  begin
    if SubBomber[3]=1 then
      WaveMix1.Play( 3, w[3], nil, WMIX_QUEUEWAVE, 0 );
    SubBomber[3]:=2;
    SubBomb3.Picture:=Explode.Picture;
  end;
  if Sub2Bomb3.Top < 80 then
  begin
    if Sub2Bomber[3]=1 then
      WaveMix1.Play( 4, w[4], nil, WMIX_QUEUEWAVE, 0 );
    Sub2Bomber[3]:=2;
    Sub2Bomb3.Picture:=Explode.Picture;
  end;

  if SubBomb1.Top < 50 then
    SubBomber[1]:=0;
  if Sub2Bomb1.Top < 50 then
    Sub2Bomber[1]:=0;
  if SubBomb2.Top < 50 then
    SubBomber[2]:=0;
  if Sub2Bomb2.Top < 50 then
    Sub2Bomber[2]:=0;
  if SubBomb3.Top < 50 then
    SubBomber[3]:=0;
  if Sub2Bomb3.Top < 50 then
    Sub2Bomber[3]:=0;

  if ((Bomb1.Top > Sub.Top) and
     (Bomb1.Top < Sub.Top+Sub.Height) and
     (Bomb1.Left > Sub.Left) and
     (Bomb1.Left < Sub.Left+Sub.Width)) or
     ((Bomb2.Top > Sub.Top) and
     (Bomb2.Top < Sub.Top+Sub.Height) and
     (Bomb2.Left > Sub.Left) and
     (Bomb2.Left < Sub.Left+Sub.Width)) or
     ((Bomb3.Top > Sub.Top) and
     (Bomb3.Top < Sub.Top+Sub.Height) and
     (Bomb3.Left > Sub.Left) and
     (Bomb3.Left < Sub.Left+Sub.Width)) or
     ((Bomb4.Top > Sub.Top) and
     (Bomb4.Top < Sub.Top+Sub.Height) and
     (Bomb4.Left > Sub.Left) and
     (Bomb4.Left < Sub.Left+Sub.Width)) or
     ((Bomb5.Top > Sub.Top) and
     (Bomb5.Top < Sub.Top+Sub.Height) and
     (Bomb5.Left > Sub.Left) and
     (Bomb5.Left < Sub.Left+Sub.Width)) then
  begin
    if SubLever then
    begin
      if (bomber[1]=1) or (bomber[2]=1) or
         (bomber[3]=1) or (bomber[4]=1) or
         (bomber[5]=1) then
        WaveMix1.Play( 3, w[3], nil, WMIX_QUEUEWAVE, 0 );
      if bomber[1]=1 then
        Bomber[1]:=2;
      if bomber[2]=1 then
        Bomber[2]:=2;
      if bomber[3]=1 then
        Bomber[3]:=2;
      if bomber[4]=1 then
        Bomber[4]:=2;
      if bomber[5]=1 then
        Bomber[5]:=2;
      Bomb1.Picture:=Explode.Picture;
      Bomb2.Picture:=Explode.Picture;
      Bomb3.Picture:=Explode.Picture;
      Bomb4.Picture:=Explode.Picture;
      Bomb5.Picture:=Explode.Picture;
      Score.Caption:=IntToStr(StrToInt(Score.Caption)+500);
      SubDuktig:=SubDuktig+10;
    end;
    SubLever:=False;
    Sub.AutoSize:=False;
    Sub.Stretch:=True;
    Sub.Picture:=Explode.Picture;
    TimerDod.Enabled:=True;
  end;

  if ((Bomb1.Top > Sub2.Top) and
     (Bomb1.Top < Sub2.Top+Sub2.Height) and
     (Bomb1.Left > Sub2.Left) and
     (Bomb1.Left < Sub2.Left+Sub2.Width)) or
     ((Bomb2.Top > Sub2.Top) and
     (Bomb2.Top < Sub2.Top+Sub2.Height) and
     (Bomb2.Left > Sub2.Left) and
     (Bomb2.Left < Sub2.Left+Sub2.Width)) or
     ((Bomb3.Top > Sub2.Top) and
     (Bomb3.Top < Sub2.Top+Sub2.Height) and
     (Bomb3.Left > Sub2.Left) and
     (Bomb3.Left < Sub2.Left+Sub2.Width)) or
     ((Bomb4.Top > Sub2.Top) and
     (Bomb4.Top < Sub2.Top+Sub2.Height) and
     (Bomb4.Left > Sub2.Left) and
     (Bomb4.Left < Sub2.Left+Sub2.Width)) or
     ((Bomb5.Top > Sub2.Top) and
     (Bomb5.Top < Sub2.Top+Sub2.Height) and
     (Bomb5.Left > Sub2.Left) and
     (Bomb5.Left < Sub2.Left+Sub2.Width)) then
  begin
    if Sub2Lever then
    begin
      if (bomber[1]=1) or (bomber[2]=1) or
         (bomber[3]=1) or (bomber[4]=1) or
         (bomber[5]=1) then
        WaveMix1.Play( 4, w[4], nil, WMIX_QUEUEWAVE, 0 );
      if bomber[1]=1 then
        Bomber[1]:=2;
      if bomber[2]=1 then
        Bomber[2]:=2;
      if bomber[3]=1 then
        Bomber[3]:=2;
      if bomber[4]=1 then
        Bomber[4]:=2;
      if bomber[5]=1 then
        Bomber[5]:=2;
      Bomb1.Picture:=Explode.Picture;
      Bomb2.Picture:=Explode.Picture;
      Bomb3.Picture:=Explode.Picture;
      Bomb4.Picture:=Explode.Picture;
      Bomb5.Picture:=Explode.Picture;
      Score.Caption:=IntToStr(StrToInt(Score.Caption)+500);
      SubDuktig:=SubDuktig+10;
    end;
    Sub2Lever:=False;
    Sub2.AutoSize:=False;
    Sub2.Stretch:=True;
    Sub2.Picture:=Explode.Picture;
    TimerDod.Enabled:=True;
  end;

  if (((Bomb1.Top > Sub.Top-SubDuktig) and
     (Bomb1.Top < Sub.Top+Sub.Height) and
     (Bomb1.Left < Sub.Left+20) and
     (Bomb1.Left > Sub.Left-SubDuktig)) or
     ((Bomb2.Top > Sub.Top-SubDuktig) and
     (Bomb2.Top < Sub.Top+Sub.Height) and
     (Bomb2.Left < Sub.Left+20) and
     (Bomb2.Left > Sub.Left-SubDuktig)) or
     ((Bomb3.Top > Sub.Top-SubDuktig) and
     (Bomb3.Top < Sub.Top+Sub.Height) and
     (Bomb3.Left < Sub.Left+20) and
     (Bomb3.Left > Sub.Left-SubDuktig)) or
     ((Bomb4.Top > Sub.Top-SubDuktig) and
     (Bomb4.Top < Sub.Top+Sub.Height) and
     (Bomb4.Left < Sub.Left+20) and
     (Bomb4.Left > Sub.Left-SubDuktig)) or
     ((Bomb5.Top > Sub.Top-SubDuktig) and
     (Bomb5.Top < Sub.Top+Sub.Height) and
     (Bomb5.Left < Sub.Left+20) and
     (Bomb5.Left > Sub.Left-SubDuktig))) and
      SubLever then
  begin
    SubVanster:=False;
    Sub.Picture:=SubRight.Picture;
    SubUpp:=False;
  end;

  if (((Bomb1.Top > Sub2.Top-SubDuktig) and
     (Bomb1.Top < Sub2.Top+Sub2.Height) and
     (Bomb1.Left < Sub2.Left+20) and
     (Bomb1.Left > Sub2.Left-SubDuktig)) or
     ((Bomb2.Top > Sub2.Top-SubDuktig) and
     (Bomb2.Top < Sub2.Top+Sub2.Height) and
     (Bomb2.Left < Sub2.Left+20) and
     (Bomb2.Left > Sub2.Left-SubDuktig)) or
     ((Bomb3.Top > Sub2.Top-SubDuktig) and
     (Bomb3.Top < Sub2.Top+Sub2.Height) and
     (Bomb3.Left < Sub2.Left+20) and
     (Bomb3.Left > Sub2.Left-SubDuktig)) or
     ((Bomb4.Top > Sub2.Top-SubDuktig) and
     (Bomb4.Top < Sub2.Top+Sub2.Height) and
     (Bomb4.Left < Sub2.Left+20) and
     (Bomb4.Left > Sub2.Left-SubDuktig)) or
     ((Bomb5.Top > Sub2.Top-SubDuktig) and
     (Bomb5.Top < Sub2.Top+Sub2.Height) and
     (Bomb5.Left < Sub2.Left+20) and
     (Bomb5.Left > Sub2.Left-SubDuktig))) and
      Sub2Lever then
  begin
    Sub2Vanster:=False;
    Sub2.Picture:=SubRight.Picture;
    Sub2Upp:=False;
  end;

  if (((Bomb1.Top > Sub.Top-SubDuktig) and
     (Bomb1.Top < Sub.Top+Sub.Height) and
     (Bomb1.Left > Sub.Left+40) and
     (Bomb1.Left < Sub.Left+Sub.Width+SubDuktig)) or
     ((Bomb2.Top > Sub.Top-SubDuktig) and
     (Bomb2.Top < Sub.Top+Sub.Height) and
     (Bomb2.Left > Sub.Left+40) and
     (Bomb2.Left < Sub.Left+Sub.Width+SubDuktig)) or
     ((Bomb3.Top > Sub.Top-SubDuktig) and
     (Bomb3.Top < Sub.Top+Sub.Height) and
     (Bomb3.Left > Sub.Left+40) and
     (Bomb3.Left < Sub.Left+Sub.Width+SubDuktig)) or
     ((Bomb4.Top > Sub.Top-SubDuktig) and
     (Bomb4.Top < Sub.Top+Sub.Height) and
     (Bomb4.Left > Sub.Left+40) and
     (Bomb4.Left < Sub.Left+Sub.Width+SubDuktig)) or
     ((Bomb5.Top > Sub.Top-SubDuktig) and
     (Bomb5.Top < Sub.Top+Sub.Height) and
     (Bomb5.Left > Sub.Left+40) and
     (Bomb5.Left < Sub.Left+Sub.Width+SubDuktig))) and
      SubLever then
  begin
    SubVanster:=True;
    SubUpp:=False;
    Sub.Picture:=SubLeft.Picture;
  end;

  if (((Bomb1.Top > Sub2.Top-SubDuktig) and
     (Bomb1.Top < Sub2.Top+Sub2.Height) and
     (Bomb1.Left > Sub2.Left+40) and
     (Bomb1.Left < Sub2.Left+Sub2.Width+SubDuktig)) or
     ((Bomb2.Top > Sub2.Top-SubDuktig) and
     (Bomb2.Top < Sub2.Top+Sub2.Height) and
     (Bomb2.Left > Sub2.Left+40) and
     (Bomb2.Left < Sub2.Left+Sub2.Width+SubDuktig)) or
     ((Bomb3.Top > Sub2.Top-SubDuktig) and
     (Bomb3.Top < Sub2.Top+Sub2.Height) and
     (Bomb3.Left > Sub2.Left+40) and
     (Bomb3.Left < Sub2.Left+Sub.Width+SubDuktig)) or
     ((Bomb4.Top > Sub2.Top-SubDuktig) and
     (Bomb4.Top < Sub2.Top+Sub2.Height) and
     (Bomb4.Left > Sub2.Left+40) and
     (Bomb4.Left < Sub2.Left+Sub2.Width+SubDuktig)) or
     ((Bomb5.Top > Sub2.Top-SubDuktig) and
     (Bomb5.Top < Sub2.Top+Sub2.Height) and
     (Bomb5.Left > Sub2.Left+40) and
     (Bomb5.Left < Sub2.Left+Sub2.Width+SubDuktig))) and
      Sub2Lever then
  begin
    Sub2Vanster:=True;
    Sub2Upp:=False;
    Sub2.Picture:=SubLeft.Picture;
  end;

end;

procedure TForm1.TimerDodTimer(Sender: TObject);
var I:Integer;
begin
  if not Lever then
  begin
    Vanster:=False;
    Lever:=True;
    Boat.Picture:=BoatRight.Picture;
    Boat.Left:=-70;
    Boat.Top:=58;
    Dec(Liv);
    if Liv=2 then
      Liv3.Visible:=False
    else if Liv=1 then
      Liv2.Visible:=False
    else
    begin
      Liv1.Visible:=False;
      for I:=1 to 5 do
        Bomber[I]:=0;

      Bomb1.Visible:=False;
      Bomb2.Visible:=False;
      Bomb3.Visible:=False;
      Bomb4.Visible:=False;
      Bomb5.Visible:=False;
      Bomb1.Top:=1;
      Bomb2.Top:=1;
      Bomb3.Top:=1;
      Bomb4.Top:=1;
      Bomb5.Top:=1;

      Boat.Top:=-40;
      TimerBoat.Enabled:=False;
      TimerPlane.Enabled:=False;
      Plane.Left:=-50;
      Man.Visible:=False;
      PanelSky.Cursor:=CrDefault;
      PanelWater.Caption:='Game Over';
      Continue1.Enabled:=False;
      Form1.KeyPreview:=False;
      if StrToInt(Score.Caption) > HighScore[9] then
      begin
        HighText.Enabled:=True;
        PanelHigh.Visible:=True;
        Save.Visible:=True;
        HighText.Text:='Name?';
      end;
    end;
  end;

  if not SubLever then
  begin
    SubVanster:=True;
    SubUpp:=True;
    SubLever:=True;
    Sub.Picture:=SubLeft.Picture;
    Sub.Top:=420;
    Sub.Left:=random(400)+10;
  end;

  if not Sub2Lever then
  begin
    Sub2Vanster:=True;
    Sub2Upp:=True;
    Sub2Lever:=True;
    Sub2.Picture:=SubLeft.Picture;
    Sub2.Top:=420;
    Sub2.Left:=random(400)+10;
  end;

  TimerDod.Enabled:=False;
end;

procedure TForm1.TimerWaveTimer(Sender: TObject);
var R:Integer;
begin
  Wave.Left:=Random(510)+2;
  Wave.Top:=72+Random(3);

  Cloud.Left:=Cloud.Left+random(2);

  if Cloud.Left>530 then
  begin
    Cloud.Top:=10+random(10)+1;
    Cloud.Left:=-40;
  end;
  Man.Picture:=ManOrg.Picture;
  if ManVanster then
    Man.Left:=Man.Left-1
  else
    Man.Left:=Man.Left+1;

  if Man.Left < 305 then
    ManVanster:=False;
  if Man.Left > 380 then
    ManVanster:=True;

  if not PlaneLever then
  begin
    R:=Random(50);
    if R=1 then
      PlaneLever:=True;
    R:=Random(2);
    if R = 1 then
    begin
      Plane.Left:= 600;
      Plane.Picture:=PlaneLeft.Picture;
      Plane.Top:=10+random(30);
      PlaneVanster:=True;
    end
    else
    begin
      Plane.Left:= -100;
      Plane.Picture:=PlaneRight.Picture;
      Plane.Top:=10+random(30);
      PlaneVanster:=False;
    end;
  end;
end;

procedure TForm1.PlaneClick(Sender: TObject);
begin
  if PlaneLever then
    Score.Caption:=IntToStr(StrToInt(Score.Caption)+50);
  WaveMix1.Play( 5, w[5], nil, WMIX_QUEUEWAVE, 0 );
  WaveMix1.Play( 4, w[4], nil, WMIX_QUEUEWAVE, 0 );
  Plane.Picture:=Explode.Picture;
  PlaneLever:=False;
end;

procedure TForm1.TimerPlaneTimer(Sender: TObject);
begin
  if PlaneLever then
  begin
    if PlaneVanster then
      Plane.Left:=Plane.Left-4
    else
      Plane.Left:=Plane.Left+4;
  end;

  if Plane.Left>600 then
    PlaneLever:=False;
  if Plane.Left<-100 then
    PlaneLever:=False;
end;

procedure TForm1.OKClick(Sender: TObject);
var S:TShiftState;
  Key:Word;
begin
  PanelHelp.Visible:=False;
  key:=13;
  OnKeyUp(Sender,key, S);
end;

procedure TForm1.ManClick(Sender: TObject);
begin
  if liv>0 then
    WaveMix1.Play( 5, w[5], nil, WMIX_QUEUEWAVE, 0 );
  Man.Picture:=Explode.Picture;
  Man.Left:=310+random(70);
  Score.Caption:=IntToStr(StrToInt(Score.Caption)+5);
end;

procedure TForm1.New1Click(Sender: TObject);
var I:Integer;
begin
  PanelSky.Cursor:=CrCross;
  PanelWater.Caption:='';
  SubDuktig:=0;
  Score.Caption:='0';
  Liv:=3;
  PlaneLever:=False;
  Lever:=True;
  SubLever:=True;
  Sub2Lever:=True;
  Boat.Left:=-70;
  Boat.Top:=58;
  Sub.Left:=random(530);
  Sub2.Left:=random(530);
  Boat.Top:=295;
  Sub.Top:=420;
  Sub2.Top:=420;
  SubUpp:=True;
  Sub2Upp:=True;
  Liv1.Visible:=True;
  Liv2.Visible:=True;
  Liv3.Visible:=True;
  Man.Visible:=True;

  for I:=1 to 5 do
    Bomber[I]:=0;
  for I:=1 to 3 do
    SubBomber[I]:=0;
  for I:=1 to 3 do
    Sub2Bomber[I]:=0;

  Bomb1.Visible:=False;
  Bomb2.Visible:=False;
  Bomb3.Visible:=False;
  Bomb4.Visible:=False;
  Bomb5.Visible:=False;
  Bomb1.Top:=1;
  Bomb2.Top:=1;
  Bomb3.Top:=1;
  Bomb4.Top:=1;
  Bomb5.Top:=1;

  SubBomb1.Visible:=False;
  SubBomb2.Visible:=False;
  SubBomb3.Visible:=False;
  SubBomb1.Top:=400;
  SubBomb2.Top:=400;
  SubBomb3.Top:=400;

  Sub2Bomb1.Visible:=False;
  Sub2Bomb2.Visible:=False;
  Sub2Bomb3.Visible:=False;
  Sub2Bomb1.Top:=400;
  Sub2Bomb2.Top:=400;
  Sub2Bomb3.Top:=400;

  TimerBoat.Enabled:=True;
  TimerSub.Enabled:=True;
  TimerWave.Enabled:=True;
  TimerPlane.Enabled:=True;

end;

procedure TForm1.About1Click(Sender: TObject);
begin
  Showmessage('SubHunt V1.0 (C)1997 Henrik Tingstrm');
end;

procedure TForm1.Continue1Click(Sender: TObject);
begin
  PanelWater.Caption:='';
  TimerBoat.Enabled:=True;
  TimerSub.Enabled:=True;
  TimerWave.Enabled:=True;
  TimerPlane.Enabled:=True;
end;

procedure TForm1.Help1Click(Sender: TObject);
begin
  PanelHelp.Visible:=True;

end;

procedure TForm1.Quit1Click(Sender: TObject);
begin
  Close;

end;

procedure TForm1.Game1Click(Sender: TObject);
var S:TShiftState;
  Key:Word;
begin
  key:=49;
  OnKeyUp(Sender,key, S);
end;

procedure TForm1.HighScore1Click(Sender: TObject);
begin
  PanelHigh.Visible:=True;
  HighText.Enabled:=False;
  HighText.Text:='';
end;

procedure TForm1.HighTextExit(Sender: TObject);
var HS, I:Integer;
    S:String;
begin
  HS:=StrToInt(Score.Caption);
  S:=HighText.Text;
  if HS > HighScore[9] then
  begin
    HighScore[9]:=HS;
    if HS > 99999 then
      HighList.Items[9]:=IntToStr(HS)+ ' '+S
    else if HS > 9999 then
      HighList.Items[9]:=IntToStr(HS)+ '  '+S
    else if HS > 999 then
      HighList.Items[9]:=IntToStr(HS)+ '   '+S
    else if HS > 99 then
      HighList.Items[9]:=IntToStr(HS)+ '    '+S
    else if HS > 9 then
      HighList.Items[9]:=IntToStr(HS)+ '     '+S
    else
      HighList.Items[9]:=IntToStr(HS)+ '      '+S;

    I:=9;
    While I>0 do
    begin
      if HighScore[I]>HighScore[I-1] then
      begin
         HS:=HighScore[I];
         S:=HighList.Items[I];
         HighScore[I]:=HighScore[I-1];
         HighList.Items[I]:=HighList.Items[I-1];
         HighScore[I-1]:=HS;
         HighList.Items[I-1]:=S;
      end;
      Dec(I);
    end;
  end;

  DeleteFile('subhunt.qwe');
  S:='SubHunt.qwe';
  assignfile(IniFile,'SubHunt.$$$');
  ReWrite(IniFile);
  for i:=0 to 9 do
  begin
    write(IniFile,HighScore[I]);
    writeln(IniFile,'');
  end;
  for i:=0 to 9 do
  begin
    write(IniFile,HighList.Items[I]);
    writeln(IniFile,'');
  end;
  closefile(IniFile);
  RenameFile('SubHunt.$$$','subhunt.qwe');

  HighText.Text:='';
  Save.Visible:=False;
  HighText.Enabled:=False;
  Form1.KeyPreview:=True;

end;

procedure TForm1.OK2Click(Sender: TObject);
var S:TShiftState;
  Key:Word;
begin
  PanelHigh.Visible:=False;
  key:=13;
  OnKeyUp(Sender,key, S);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  WaveMix1.Close( w[5] );
  WaveMix1.Close( w[4] );
  WaveMix1.Close( w[3] );
  WaveMix1.Close( w[2] );
  WaveMix1.Close( w[1] );
  WaveMix1.Close( w[0] );

end;

procedure TForm1.PanelSkyClick(Sender: TObject);
begin
  if liv>0 then
    WaveMix1.Play( 5, w[5], nil, WMIX_QUEUEWAVE, 0 );

end;

procedure TForm1.IslandClick(Sender: TObject);
begin
  if liv>0 then
    WaveMix1.Play( 5, w[5], nil, WMIX_QUEUEWAVE, 0 );
end;

end.
